#
# Exercice 1
#
library(MASS)
attach(Boston)

# Q1
plot(crim,medv)
plot(nox,medv)
plot(dis,medv)
plot(rad,medv)
plot(lstat,medv)

fit=lm(medv~poly(lstat,3),data=Boston)
x<-seq(min(lstat)-10,max(lstat)+10,0.1)
pred<-predict(fit,newdata=data.frame(lstat=x))
plot(lstat,medv)
lines(x,pred,col="red",lwd=2)

fit=lm(medv~poly(lstat,5),data=Boston)
pred<-predict(fit,newdata=data.frame(lstat=x))
plot(lstat,medv)
lines(x,pred,col="red",lwd=2)

# Q2

# 10-fold cross-validation
K<-10
n<-nrow(Boston)
folds=sample(1:K,n,replace=TRUE)
P<-1:10
N<-length(P)
CV1<-rep(0,N)
for(i in (1:N)){
  print(i)
  for(k in (1:K)){
    fit=lm(medv~poly(lstat,P[i]),data=Boston[folds!=k,])
    pred<-predict(fit,newdata=Boston[folds==k,])
    CV1[i]<-CV1[i]+ sum((Boston$medv[folds==k]-pred)^2)
  }
  CV1[i]<-CV1[i]/n
}
plot(P,CV1,type='b',xlab='p',ylab='CV error')

fit=lm(medv~poly(lstat,5),data=Boston)
pred1<-predict(fit,newdata=data.frame(lstat=x))
plot(lstat,medv)
lines(x,pred1,col="red",lwd=2)


# Q3

library(splines)
fit=lm(medv~ns(lstat,df=7),data=Boston)
pred<-predict(fit,newdata=data.frame(lstat=x))
plot(lstat,medv)
lines(x,pred,col="red",lwd=2)


DF<-1:10
N<-length(DF)
CV2<-rep(0,N)
for(i in (1:N)){
  print(i)
  for(k in (1:K)){
    fit=lm(medv~ns(lstat,df=DF[i]),data=Boston[folds!=k,])
    pred<-predict(fit,newdata=Boston[folds==k,])
    CV2[i]<-CV2[i]+ sum((Boston$medv[folds==k]-pred)^2)
  }
  CV2[i]<-CV2[i]/n
}
plot(DF,CV2,type='b',xlab='df',ylab='CV error')


fit=lm(medv~ns(lstat,df=4),data=mcycle)
pred2<-predict(fit,newdata=data.frame(lstat=x))
plot(lstat,medv)
lines(x,pred2,col="red",lwd=2)
lines(x,pred1,col="blue",lwd=2)

# Q4

fit=smooth.spline(Boston$lstat,Boston$medv,cv=TRUE)
dfopt<-fit$df
fit=smooth.spline(Boston$lstat,Boston$medv,df=dfopt)
plot(lstat,medv)
lines(fit$x,fit$y,col="red",lwd=2)

DF<-seq(8,15,0.5)
N<-length(DF)
CV3<-rep(0,N)
for(i in (1:N)){
  print(i)
  for(k in (1:K)){
    fit=smooth.spline(Boston$lstat[folds!=k],Boston$medv[folds!=k],
                      df=DF[i])
    pred<-predict(fit,Boston$lstat[folds==k])
    CV3[i]<-CV3[i]+ sum((Boston$medv[folds==k]-pred$y)^2)
  }
  CV3[i]<-CV3[i]/n
}
plot(DF,CV3,type='b',xlab='df',ylab='CV error')


# Q5
fit=smooth.spline(Boston$lstat,Boston$medv,df=dfopt)
pred3<-predict(fit,newdata=data.frame(lstat=x))

plot(lstat,medv)
lines(x,pred2,col="red",lwd=2)
lines(x,pred1,col="blue",lwd=2)
lines(pred3$x,pred3$y,col="green",lwd=2)

min(CV1)
min(CV2)
min(CV3)



# Exercise 2

library(gam)
fit<-gam(medv ~ s(crim) + s(lstat) + s(dis) + s(nox),
         data=Boston,trace=TRUE)
plot(fit,residuals=TRUE)



K<-5
folds=sample(1:K,n,replace=TRUE)


# Q1
mse.gam<-function(par,folds){
  K<-max(folds)
  par<-abs(par)
  ERR<-0
  j0<-par[1]
  k0<-par[2]
  l0<-par[3]
  q0<-par[4]
  for(i in 1:K){
    fit<-gam(medv ~ s(crim,j0)+ s(lstat,k0) + s(dis,l0) + s(nox,q0),
             data=Boston[folds!=i,],trace=FALSE)
    pred<-predict(fit,newdata=Boston[folds==i,],type='response')
    ERR<-ERR+ sum((Boston$medv[folds==i]-pred)^2)
  }
  return(ERR/nrow(Boston))
}

# Q2
opt<-optim(par=c(4,4,4,4),fn=mse.gam,folds=folds,control = list(trace=1))

# Q3
print(opt$par)

fit<-gam(medv ~ s(crim,5.3428695) + s(lstat,5.3944833) 
         + s(dis,1.7707661) + s(nox,0.9996618),
         data=Boston,trace=TRUE)
plot(fit,residuals=TRUE,pch='.')



